import 'package:danger_core/src/mock_json_annotation.dart';
import 'package:danger_core/src/models/violation.dart';

part 'danger_results.g.dart';

class DangerResults {
  final List<Violation> fails;

  final List<Violation> warnings;

  final List<Violation> messages;

  final List<Violation> markdowns;

  final DangerResultMetaData meta;

  DangerResults(
      {required this.fails,
      required this.warnings,
      required this.messages,
      required this.markdowns,
      this.meta = const DangerResultMetaData()});

  factory DangerResults.fromJson(Map<String, dynamic> json) =>
      _$DangerResultsFromJson(json);
  Map<String, dynamic> toJson() => _$DangerResultsToJson(this);
}

class DangerResultMetaData {
  final String runtimeName;
  final String runtimeHref;

  const DangerResultMetaData(
      {this.runtimeName = 'Danger Dart',
      this.runtimeHref = 'https://danger.systems/dart'});

  factory DangerResultMetaData.fromJson(Map<String, dynamic> json) =>
      _$DangerResultMetaDataFromJson(json);
  Map<String, dynamic> toJson() => _$DangerResultMetaDataToJson(this);
}