import 'package:danger_core/src/mock_json_annotation.dart';

part 'violation.g.dart';

enum ViolationType {
  message,
  warn,

  fail,

  markdown,
}

class Violation {
  /// The string representation
  final String message;

  /// Optional path to the file
  final String? file;

  /// Optional line in the file
  final int? line;

  /// Optional icon for table (Only valid for messages)
  final String? icon;

  factory Violation.fromJson(Map<String, dynamic> json) =>
      _$ViolationFromJson(json);

  Violation({required this.message, this.file, this.line, this.icon});
  Map<String, dynamic> toJson() => _$ViolationToJson(this);
}

class WrappedViolation {
  final ViolationType type;
  final Violation violation;

  WrappedViolation({required this.type,required  this.violation});

  factory WrappedViolation.fromJson(Map<String, dynamic> json) =>
      _$WrappedViolationFromJson(json);
  Map<String, dynamic> toJson() => _$WrappedViolationToJson(this);
}